package com.alibaba.fastjson.serializer;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class SimpleDataFormatSerializer implements ObjectSerializer {

    private final String                        pattern;
    private final ThreadLocal<SimpleDateFormat> formatLocal = new ThreadLocal<SimpleDateFormat>();

    public SimpleDataFormatSerializer(String pattern){
        this.pattern = pattern;
    }

    public String getPattern() {
        return this.pattern;
    }

    public void write(JSONSerializer serializer, Object object) throws IOException {
        Date date = (Date) object;
        SimpleDateFormat format = formatLocal.get();

        if (format == null) {
            format = new SimpleDateFormat(pattern);
            formatLocal.set(format);
        }

        String text = format.format(date);
        serializer.write(text);
    }
}
